#pragma once
#include "webview_client.h"
#include <flutter/texture_registrar.h>
#include <flutter/event_channel.h>
#include <flutter/standard_method_codec.h>
#include <flutter/method_channel.h>

class WebviewBridge 
{
public:
    int64_t texture_id() const
    {
        return texture_id_;
    }
   
    WebviewBridge(flutter::TextureRegistrar *texture_registrar, flutter::BinaryMessenger *messenger);
 
    ~WebviewBridge();
   

private:
    /* data */
    int64_t texture_id_;
    // CefRefPtr<WebviewClient> webview_client_;
    std::unique_ptr<flutter::TextureVariant> flutter_texture_;
    flutter::TextureRegistrar *texture_registrar_;
    flutter::BinaryMessenger *binary_messenger_;

    std::unique_ptr<flutter::MethodChannel<flutter::EncodableValue>>
        method_channel_;
    std::unique_ptr<flutter::EventChannel<flutter::EncodableValue>>
        event_channel_;
    std::unique_ptr<flutter::EventSink<flutter::EncodableValue>> event_sink_;
   

    void HandleMethodCall(
        const flutter::MethodCall<flutter::EncodableValue> &method_call,
        std::unique_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
    void RegisterEventHandlers();
    
};
